import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Formatter;

/**
 * 
 */

/**
 * @author Galo
 *
 */
public class PidgeonCNFGenerator {

	private static int fact(int n){
	
		int r = 1;
		if(n<=0){
			return r;
		}else{
			while(n>0){
				r *= n;
				n--;
			}
		}
		return r;
	}
	
	private static int nCr(int n, int k){
		return (fact(n)/(fact(k)*fact(n-k)));
	}
	
	public static void main (String[] args) throws IOException{
		int n = 0;
		if(args.length == 1){
			n = Integer.parseInt(args[0]);
		}
		
		PrintWriter out = new PrintWriter(new FileWriter("pidgeon-n"+n+".cnf"));
		Formatter s = new Formatter();
		
		s.format("c Pidgeon Formula Autogenerated by PidgeonCNFGenerator.java%n");
		s.format("c Author: Gabriel Corvera - Cornell / ITESM%n");
		//p cnf variables clauses
		s.format("p cnf %s %s %n",(n*(n+1)),((n+1)+nCr(n,2)*(n+1)+nCr(n+1,2)*n)); 
	
		//Each pidgeon can be in any box
		for(int i = 1; i <= (n*(n+1)); i++){
			if(i%n==0){
				s.format("%s 0%n",i);
			}else{
				s.format("%s ",i);
			}
		}
		
		//One pidgeon per box
		for(int i = 1; i <= (n*(n+1)); i++){
			int j = i;
			while(j%n!=0){
				j++;
				s.format("%s %s 0%n",-i,-j);
			}	
			
		}
		
		//Only one box per pidgeon
		for(int i = 1; i <= (n*(n+1)); i++){
			for(int j = (i+n); j <= (n*(n+1)); j+=n){			
				s.format("%s %s 0%n",-i,-j);
			}	
			
		}
		
		System.out.println("Pidgeon problem CNF file for n = " + n + " generated.");
		out.print(s);
		out.close();		
	}
	
}
